package RATSdes;

use 5.006;
use strict;
use warnings;
use Carp;

require Exporter;
require DynaLoader;
use AutoLoader;

our @ISA = qw(Exporter DynaLoader);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration	use RATSdes ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
	
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
	
);
our $VERSION = '0.01';

sub AUTOLOAD {
    # This AUTOLOAD is used to 'autoload' constants from the constant()
    # XS function.  If a constant is not found then control is passed
    # to the AUTOLOAD in AutoLoader.

    my $constname;
    our $AUTOLOAD;
    ($constname = $AUTOLOAD) =~ s/.*:://;
    croak "& not defined" if $constname eq 'constant';
    my $val = constant($constname, @_ ? $_[0] : 0);
    if ($! != 0) {
	if ($! =~ /Invalid/ || $!{EINVAL}) {
	    $AutoLoader::AUTOLOAD = $AUTOLOAD;
	    goto &AutoLoader::AUTOLOAD;
	}
	else {
	    croak "Your vendor has not defined RATSdes macro $constname";
	}
    }
    {
	no strict 'refs';
	# Fixed between 5.005_53 and 5.005_61
	if ($] >= 5.00561) {
	    *$AUTOLOAD = sub () { $val };
	}
	else {
	    *$AUTOLOAD = sub { $val };
	}
    }
    goto &$AUTOLOAD;
}

bootstrap RATSdes $VERSION;

# Preloaded methods go here.

# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__
# Below is stub documentation for your module. You better edit it!

=head1 NAME

RATSdes - Perl extension for blah blah blah

=head1 SYNOPSIS

  use RATSdes;

  $enc = &RATSdes::rats_encrypt($data, $key1, $key2, length);
  $dec = &RATSdes::rats_decrypt($enc, $key1, $key2, length);


=head1 DESCRIPTION

These are the RATS encryption and decryption routines. Underneath they
are just triple DES built upon the openssl crypt libraries. These are 
meant to be used in the context of the RATS software. The only things
to be aware are the data  format and the definition of length. The 
output of the encrypt function will be binary data, and it should be 
treat it with care. The length argument is in both cases the length of
the encrypted string. For decrypt this is need it so we can tell when to
stop decrypting the binary data (which may include null's). For encrypt
the length is requiered by the XS glue as to know how much data to return, 
again due to the possiblity of nulls. If you choose to change the code 
of this module, the test provided will generate nulls in the data with the
chosen data and keys and should be used to verify the proper handling of 
data. To obtain the appropriate length to feed to these to functions, two
different methods are requiered. For the encrypt function, you need to 
calculate it yourself by increasing the size of the data to the next 8byte
divisible block (ie: a 5byte data block needs a length of 8, and a 15byte
data block would need 16). For the decrypt function you could use Perl's 
native functions to mesure it, or (the way that RATS does it) use the size
read from the network connection providing the data. More about that can be
found in the RATS documentation. 

=head2 EXPORT

None by default.


=head1 AUTHOR

Vladimir Gabrielescu, E<lt>vgabriel@nbcs.rutgers.edu<gt>

=head1 SEE ALSO

L<perl>.
the RATS documentation

=cut
